﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Controls.Grids;
using System.Windows.Markup;
using System.Diagnostics;

namespace TextColumnWithParameter
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            Data = new ObservableCollection<Person>
            {
                new Person { Name = "P 1", Age = "1", CheckedProp = false },
                new Person { Name = "P 2", Age = "2", CheckedProp = true },
            };

            DataContext = this;
        }

        public ObservableCollection<Person> Data { get; set; }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            TemplateColumn temp = new TemplateColumn();
            temp.Key = "CheckedProp";

            string str = "<DataTemplate xmlns=" + "\"http://schemas.microsoft.com/winfx/2006/xaml/presentation\" xmlns:x=" + "\"http://schemas.microsoft.com/winfx/2006/xaml\">"
                            + "<StackPanel Orientation=\"Horizontal\">"
                                + "<RadioButton x:Name=\"rButton\" IsChecked=\"{Binding Path=CheckedProp}\" GroupName=\"A\">"
                                    + "<TextBlock Text=\"{Binding Path=CheckedProp}\"/>"
                                + "</RadioButton>"
                            + "</StackPanel>"
                       +" </DataTemplate>";

            temp.ItemTemplate = XamlReader.Load(str) as DataTemplate;
            xamGrid1.Columns.Add(temp);
        }

        private void xamGrid1_CellControlAttached(object sender, CellControlAttachedEventArgs e)
        {
            if (e.Cell.Column.Key.Equals("CheckedProp"))
            {
                Dispatcher.BeginInvoke(new Action(() =>
                {
                    RadioButton rb = GetChildFromName(e.Cell.Control, "rButton") as RadioButton;
                    if (rb != null)
                    {
                        rb.Checked += new RoutedEventHandler(CheckBox_Checked);
                        rb.Unchecked += new RoutedEventHandler(CheckBox_Unchecked);
                    }
                }));
            }
        }

        void CheckBox_Unchecked(object sender, RoutedEventArgs e)
        {
            Debug.WriteLine(sender);
        }

        void CheckBox_Checked(object sender, RoutedEventArgs e)
        {
            Debug.WriteLine(sender);
        }


        private FrameworkElement GetChildFromName(DependencyObject parent, string name)
        {
            FrameworkElement result = null;

            for (int i = 0; i < VisualTreeHelper.GetChildrenCount(parent); i++)
            {
                if (VisualTreeHelper.GetChild(parent, i) is FrameworkElement
                    && (VisualTreeHelper.GetChild(parent, i) as FrameworkElement).Name.Equals(name))
                {
                    return VisualTreeHelper.GetChild(parent, i) as FrameworkElement;
                }
                else
                {
                    result = GetChildFromName(VisualTreeHelper.GetChild(parent, i), name);

                    if (result != null)
                    {
                        break;
                    }
                }
            }
            return result;
        }
    }

    public class Person
    {
        public string Name { get; set; }
        public string Age { get; set; }
        public bool CheckedProp { get; set; }
    }

}
